using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.Data;
using System.Web;

using Cuyahoga.Core; //Contains: INHibernateModule
using Cuyahoga.Core.Domain; //Contains: ModuleBase
using Cuyahoga.Core.Service;
using Cuyahoga.Core.Search;
using Cuyahoga.Core.Util;
using Cuyahoga.Core.Communication;

using Cuyahoga.Web.Util;
using Cuyahoga.Core.DataAccess; //Contains: ICommonDao
using Castle.Services.Transaction;
using Castle.Core;

using Cuyahoga.Modules.Company.DataAccess; //Needed or: 'as it has dependencies to be satisfied'
using Cuyahoga.Modules.Company.Domain;

namespace Cuyahoga.Modules.Company
{
    [Transactional]
    public class CompanyModule : ModuleBase, INHibernateModule//, IActionConsumer, IActionProvider
    {
        private ICommonDao _commonDao;
        private ICompanyDao _companyDao;
        //private ActionCollection _inboundActions;
        //private ActionCollection _outboundActions;

        public CompanyModule(ICommonDao commonDao, ICompanyDao companyDao)
        {
            this._commonDao = commonDao;
            this._companyDao = companyDao;

            //InitInboundActions();
            //InitOutboundActions();
        }

        #region Actions
            //private void InitInboundActions()
            //{
            //    this._inboundActions = new ActionCollection();
            //    this._inboundActions.Add(new Cuyahoga.Core.Communication.Action("EditRecruiterProfile", null)); //Replace null with passed values
            //}
            //public ActionCollection GetInboundActions()
            //{
            //    return this._inboundActions;
            //}

            //private void InitOutboundActions()
            //{
            //    this._outboundActions = new ActionCollection();
            //    this._outboundActions.Add(new Cuyahoga.Core.Communication.Action("EditRecruiterProfile", null));//Replace null with passed values
            //}
            //public ActionCollection GetOutboundActions()
            //{
            //    return this._outboundActions;
            //}
        #endregion Actions

        #region Data Access
            #region Employee Module Dao Access
                public IList GetEmployees()
                {
                    return this._companyDao.GetEmployees();
                }

                public Employee GetEmployee(int employeeID)
                {
                    return this._companyDao.GetEmployee(employeeID);
                }

                public void SaveEmployee(Employee employeeToSave)
                {
                    this._companyDao.SaveEmployee(employeeToSave);
                }

                public void DeleteEmployee(Employee employeeToDelete)
                {
                    this._companyDao.DeleteEmployee(employeeToDelete);
                }
            #endregion Employee Module Dao Access

            #region Department Module Dao Access
                public IList GetDepartments()
                {
                    return this._companyDao.GetDepartments();
                }

                public Department GetDepartment(int departmentID)
                {
                    return this._companyDao.GetDepartment(departmentID);
                }

                public void SaveDepartment(Department departmentToSave)
                {
                    this._companyDao.SaveDepartment(departmentToSave);
                }

                public void DeleteDepartment(Department departmentToDelete)
                {
                    this._companyDao.DeleteDepartment(departmentToDelete);
                }
            #endregion Department Module Dao Access
        #endregion Data Access

    }
}
