-- 'Company' Module
SET DATEFORMAT ymd

-- The SQL for table creation can be generated inside SQL Server Management Studio (Express)
-- Right click on the table and 'script table as'.

CREATE TABLE [dbo].[Department](
	[Id] [bigint] IDENTITY(1,1) NOT NULL,
	[Name] [varchar](128) NULL,
 CONSTRAINT [PK_Department] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Employee](
	[Id] [bigint] IDENTITY(1,1) NOT NULL,
	[Name] [varchar](64) NULL,
	[Surname] [varchar](64) NULL,
	[ParentDepartment] [bigint] NULL,
 CONSTRAINT [PK_Employee] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO


ALTER TABLE [dbo].[Employee]  WITH CHECK ADD  CONSTRAINT [FK_Employee_Department] FOREIGN KEY([ParentDepartment])
REFERENCES [dbo].[Department] ([Id])
ON DELETE CASCADE
GO

ALTER TABLE [dbo].[Employee] CHECK CONSTRAINT [FK_Employee_Department]
GO



-- Module database entries and settings
DECLARE @moduletypeid int

INSERT INTO cuyahoga_moduletype ([name],assemblyname,classname,path,editpath,inserttimestamp,updatetimestamp) VALUES ('Company','Cuyahoga.Modules.Company','Cuyahoga.Modules.Company.CompanyModule','Modules/Company/Company.ascx', 'Modules/Company/Admin/AdminCompany.aspx', '2008-11-29 19:59:59.998', '2008-11-29 19:59:59.998')
SELECT @moduletypeid = Scope_Identity()

--INSERT INTO cuyahoga_modulesetting (moduletypeid, name, friendlyname, settingdatatype, iscustomtype, isrequired) VALUES (@moduletypeid, 'SETTING_NAME', 'Setting description text...', 'System.Boolean', 0, 1)

--NOTE: The 'servicekey' must be lower case (ToLower must be used in the code so any upper case entries do not work)
INSERT INTO cuyahoga_moduleservice (moduletypeid, servicekey, servicetype, classtype)
VALUES (@moduletypeid, 'company.companydao', 'Cuyahoga.Modules.Company.DataAccess.ICompanyDao, Cuyahoga.Modules.Company', 'Cuyahoga.Modules.Company.DataAccess.CompanyDao, Cuyahoga.Modules.Company')
GO

INSERT INTO cuyahoga_version (assembly, major, minor, patch) VALUES ('Cuyahoga.Modules.Company', 1, 6, 0)
GO
