-- 'Company' Module Uninstall

-- Delete Module Tables
-- The SQL for table deletion can be generated inside SQL Server Management Studio (Express)
-- Right click on the table and 'script table as'.

IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[dbo].[FK_Employee_Department]') AND parent_object_id = OBJECT_ID(N'[dbo].[Employee]'))
ALTER TABLE [dbo].[Employee] DROP CONSTRAINT [FK_Employee_Department]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Employee]') AND type in (N'U'))
DROP TABLE [dbo].[Employee]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Department]') AND type in (N'U'))
DROP TABLE [dbo].[Department]
GO



-- Delete System Database Entries

DELETE FROM cuyahoga_version WHERE assembly = 'Cuyahoga.Modules.Company'
GO

DELETE cuyahoga_modulesetting
FROM cuyahoga_modulesetting ms
INNER JOIN cuyahoga_moduletype mt ON mt.moduletypeid = ms.moduletypeid
AND mt.assemblyname = 'Cuyahoga.Modules.Company'
GO

DELETE cuyahoga_moduleservice
FROM cuyahoga_moduleservice ms
INNER JOIN cuyahoga_moduletype mt ON mt.moduletypeid = ms.moduletypeid AND mt.assemblyname = 'Cuyahoga.Modules.Company'
GO

DELETE FROM cuyahoga_moduletype
WHERE assemblyname = 'Cuyahoga.Modules.Company'
GO



--UNINSTALL STORED PROCEDURES

--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PROCEDURENAME]') AND type in (N'P'))
--BEGIN    
--	DROP PROCEDURE [dbo].[PROCEDURE_NAME]
--END
--GO



--UNINSTALL FUNCTIONS

--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FUNCTIONNAME]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
--DROP FUNCTION [dbo].[FUNCTIONNAME]
--GO
