using System;
using System.Data;
using System.Collections;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Cuyahoga.Web.UI;
using Cuyahoga.Web.Util;

using Cuyahoga.Core.Domain;

using Cuyahoga.Modules.Company;
using Cuyahoga.Modules.Company.Domain;


namespace Cuyahoga.Modules.Company.Web.Admin
{

    public partial class AdminCompany : ModuleAdminBasePage
    {

	//Create an instance of this module...
        private CompanyModule _Module;

        protected void Page_Load(object sender, EventArgs e)
        {
            //Get THIS module class and put it in _Module
            //ALWAYS GET AN INSTANCE OF THE MODULE
            this._Module = this.Module as CompanyModule;

            ////Add Admin Page Specific CSS and Javascript to page
            //RegisterJavascript("Company", UrlHelper.GetApplicationPath() + "Modules/Company/javascript/Company.js");
            //RegisterAdminStylesheet("Company", UrlHelper.GetApplicationPath() + "Modules/Company/css/Company.css");

            if (!Page.IsPostBack) 
            {
                gvDepartmentBind();
                ddlDepartmentBind();
                gvEmployeeBind();
            }
        }

        protected void btnDepartment_Click(object sender, EventArgs e)
        {
            Department nd = new Department();
            nd.Name = DtbName.Text;
            _Module.SaveDepartment(nd);

            gvDepartmentBind();
            ddlDepartmentBind();
        }

        private void gvDepartmentBind()
        {
            gvDepartment.DataSource = _Module.GetDepartments();
            gvDepartment.DataBind();
        }

        private void ddlDepartmentBind()
        {
            ddlDepartment.DataSource = _Module.GetDepartments();
            ddlDepartment.DataBind();
        }

        private void gvEmployeeBind()
        {
            gvEmployee.DataSource = _Module.GetEmployees();
            gvEmployee.DataBind();
        }

        protected void btnEmployee_Click(object sender, EventArgs e)
        {
            Employee ne = new Employee();
            ne.Name = tbName.Text;
            ne.Surname = tbSurname.Text;

            if (ddlDepartment.SelectedValue.ToString() != "")
            {
                int departmentId = int.Parse(ddlDepartment.SelectedValue.ToString());
                ne.ParentDepartment = _Module.GetDepartment(departmentId);
            }

            _Module.SaveEmployee(ne);

            gvEmployeeBind();
        }
    }
}

